<template>
    <div style="border: 1px solid #ccc;z-index: 100;">
      <Toolbar
        style="border-bottom: 1px solid #ccc"
        :editor="editorRef"
        :defaultConfig="toolbarConfig"
        :mode="mode"
      />
      <Editor
        style="height: 500px; overflow-y: hidden;"
        v-model="valueHtml"
        @onChange="handleChange"
        @onBlur="handleBlur"
        :defaultConfig="editorConfig"
        :mode="mode"
        @onCreated="handleCreated"
      />
    </div>
</template>

<script>
import '@wangeditor/editor/dist/css/style.css' // 引入 css

import { onBeforeUnmount, ref, shallowRef, onMounted } from 'vue'
import { Editor, Toolbar } from '@wangeditor/editor-for-vue'

import {
  useFormItem,
} from 'element-plus'


export default {
  components: { Editor, Toolbar },
  props: {
    modelValue: {
      type: String,
      default: '',
    },
    disabled:{
      type:Boolean,
      default:false
    }
  },
  emits: ['update:modelValue','change','blur'],
  watch:{
    modelValue(n,o){
      this.valueHtml = n
    }
  },
  setup(props,{ emit }) {
    //引入form-item
    const { formItem } = useFormItem()
    // 编辑器实例，必须用 shallowRef
    const editorRef = shallowRef()

    // 内容 HTML
    const valueHtml = ref('')

    // 模拟 ajax 异步获取内容
    onMounted(() => {
      setTimeout(()=>{
        valueHtml.value = props.modelValue
        // console.log(valueHtml.value);
      })
    })

    const toolbarConfig = {}
    const editorConfig = { placeholder: '请输入内容...' }

    // watch(
    //   props,modelValue,
    //   (n,o) => {
        
    //   }
    // )

    // 组件销毁时，也及时销毁编辑器
    onBeforeUnmount(() => {
        const editor = editorRef.value
        if (editor == null) return
        editor.destroy()
    })

    const handleCreated = (editor) => {
      editorRef.value = editor // 记录 editor 实例，重要！
      if(props.disabled){
        editor.disable()
      }
    }

    const handleChange = ()=>{
      emit("update:modelValue", valueHtml.value);
      // formItem?.validate?.('change').catch((err) => debugWarn(err))
    }

    const handleBlur = ()=>{
      formItem?.validate?.('blur').catch((err) => console.warn(err))
    }

    return {
      editorRef,
      valueHtml,
      mode: 'default', // 或 'simple'
      toolbarConfig,
      editorConfig,
      handleCreated,
      handleChange,
      handleBlur,
    };
  }
}
</script>   